import { BaseService } from '#application/base/baseService'
import passwordResetTokenRepository from '#repositories/passwordResetTokenRepository'

class PasswordResetTokenService extends BaseService {
  /**
   * Delete token
   * @param token
   */
  public async delete(token: string): Promise<boolean> {
    try {
      const tokenData = await passwordResetTokenRepository.getByToken(token)
      if (!tokenData) {
        return false
      }

      await tokenData.delete()

      return true
    } catch (error: any) {
      this.logger.error(`Error deleting password reset token: ${error instanceof Error ? error.message : String(error)}`)
      return false
    }
  }
}

export default new PasswordResetTokenService()
